<script lang="ts">
  import { AllTasks, tasks, type Task } from './tasks';
  import { addTreasure, dieRoll } from './wealth';
  import { getToastStore } from '@skeletonlabs/skeleton';

  const toast = getToastStore();

  /**
   * When a task is clicked on, it is considered finished and then
   * toast the completion, remove it from the list, and select
   * one of the other available tasks (i.e.) not the task nor
   * in the list of current task.
   * @param task
   */
  function finish(task: Task): void {
    const cur = $tasks;
    const diff = [...AllTasks].filter((x: Task) => cur.every((c) => x.task !== c.task));
    const rem = cur.filter((x) => x.task !== task.task);
    let earned = 0;
    if (rem.length < cur.length) {
      earned = dieRoll(task.value);
      addTreasure(task.currency, earned);
    }
    const sub = [...diff].sort(() => 0.5 - Math.random()).slice(0, 6 - rem.length);
    let newest = '';
    switch (sub.length) {
      case 0:
        newest = 'no new tasks have';
        break;
      case 1:
        newest = `<em>${sub[0].task}</em> has`;
        break;
      default:
        newest = `<em>${sub.at(-1)?.task}</em> and ${sub.length - 1} others have`;
    }
    tasks.set([...rem, ...sub]);
    toast.trigger({ message: `You earned ${earned} ${task.currency} and ${newest} been added!` });
  }
</script>

<section class="card pt-0 p-2 variant-ghost-primary">
  <header class="card-header text-lg text-center font-bold">Tasks</header>
  <article class="grid gap-2 variant-white">
    {#each $tasks as task}
      <button class="chip text-lg variant-soft hover:variant-filled" on:click={() => finish(task)}>
        {task.task}
      </button>
    {/each}
  </article>
</section>
